#!/bin/bash
echo Number of arguments passed: $#
if [[ $# -le 0 ]] ; then
   echo -e "Please, type the program to score: \c "
   read  program
   echo
   echo "Scoring program: $program"
   for i in {0..20}
   do
      echo "Generating file output$i$program.txt"
      cp input$i.txt input.txt
      /usr/bin/time -f "INSTANCE $i: %U user time, %M max resident mem, %e elapsed real time, %S system time" ./$program
      cat output.txt | tr '\n' ' ' > output$i$program.txt
      rm output.txt
      echo "Checking file output$i$program.txt against output$i.txt"
      tr '\n' ' ' < output$i.txt | diff --ignore-all-space - output$i$program.txt > diffReport$i$program.txt
      wc diffReport$i$program.txt
      echo
   done
   echo "program checked:  $program"
else
   echo
   echo "Scoring program: $1"
   for i in {0..20}
   do
      echo "Generating file output$i$1.txt"
      cp input$i.txt input.txt
      /usr/bin/time -f "INSTANCE $i: %U user time, %M max resident mem, %e elapsed real time, %S system time" ./$1
      cat output.txt | tr '\n' ' ' > output$i$1.txt
      rm output.txt
      #echo "Checking file output$i$1.txt against output$i.txt"
      tr '\n' ' ' < output$i.txt | diff --ignore-all-space - output$i$1.txt > diffReport$i$1.txt
      wc diffReport$i$1.txt
      echo
   done
   echo "program checked:  $1"
fi

