#include <fstream>
#include <climits>

using namespace std;

unsigned long long int** cache;
int disks, pegs;

inline unsigned long long int fast_2_pow(int exp){
    unsigned long long int result = 1ULL;
    result <<= exp;
    return result;
}

void init_cache(){
    cache = new unsigned long long int*[disks];
    for(int i=0; i<disks; ++i)
        cache[i]= new unsigned long long int[pegs];
    
    for(int i=0; i<disks; ++i){
        for(int j=0; j<disks; ++j){
           cache[i][j] = -1;
        }
    }
}

unsigned long long int recursive_function(int disks, int pegs){

    if(cache[disks-1][pegs-1] == -1){
        if(pegs == 3){
            cache[disks-1][pegs-1] = fast_2_pow(disks)-1;
        }

        if(pegs > 3){
            if(disks < pegs){
                cache[disks-1][pegs-1] = 2*disks-1;
            }
            else{
                unsigned long long int min = ULLONG_MAX;
                for(int removed_top_disks = 1; removed_top_disks < disks; ++removed_top_disks){
                    unsigned long long int temp= 2*recursive_function(removed_top_disks, pegs) + recursive_function(disks-removed_top_disks, pegs-1);
                    if(temp < min) min = temp;
                }
                cache[disks-1][pegs-1] = min;      
            }
        }
    }

    return cache[disks-1][pegs-1];
}

int main(){

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    fin >> disks;
    fin >> pegs;

    init_cache();

    fout << recursive_function(disks, pegs) << endl;

}
