#include <stdio.h>
#include <stdlib.h>

typedef struct _tree {
	int childrenNumber;
	struct _tree** subTree;
} Tree;

Tree* createTree(int children) {
//	printf("creo albero di %d figli\n", children);
	if(children == 0) {
		return NULL;
	}
	Tree* tree = malloc(sizeof(Tree));
	tree->childrenNumber = children;
	tree->subTree = malloc(sizeof(Tree*)*children);
	
	return tree;
}

Tree* buildTree(FILE* input) {
	int read;
	fscanf(input, "%d", &read);
	//printf("letto %d\n", read);
	
	Tree* currentRoot = createTree(read);
	int i=0;
	for(;i<read; i++) {
		*(currentRoot->subTree+i) = buildTree(input);
	}
	return currentRoot;
}

Tree* readTree() {
	FILE* input = fopen("input.txt", "r");
    
    Tree* tree = buildTree(input);
		
	fclose(input);
	return tree;
}

void writeTree_reverse(FILE* output, Tree* tree) {
	if(tree == NULL) {
//		printf("0 ");
		fprintf(output, "%d ", 0);
	} else {
//		printf("%d ", tree->childrenNumber);
		fprintf(output, "%d ", tree->childrenNumber);
		
		int i=tree->childrenNumber-1;
		for(;i>=0; i--) {
			writeTree_reverse(output, *(tree->subTree+i));
		}
	}
}

void writeTree_normal(FILE* output, Tree* tree) {
	if(tree == NULL) {
//		printf("0 ");
		fprintf(output, "%d ", 0);
	} else {
//		printf("%d ", tree->childrenNumber);
		fprintf(output, "%d ", tree->childrenNumber);
		
		int i=0;
		for(;i<tree->childrenNumber; i++) {
			writeTree_normal(output, *(tree->subTree+i));
		}
	}
}

int main() {

	Tree* tree = readTree();
	
	FILE* output = fopen("output.txt", "w");
	writeTree_reverse(output, tree);
	fclose(output);

	return 1;
}
