#include <stdio.h>
#include <stdlib.h>

typedef struct _danceFloorDesc {
	int rows;
	int columns;
} DanceFloorDesc;

typedef struct _stompDescriptor {
	int reached;
	int first;
	int second;
	int third;
} StompDescriptor;

FILE* input = NULL;

DanceFloorDesc* readDanceFloorDescription() {
	input = fopen("input.txt", "r");
	
	DanceFloorDesc* desc = malloc(sizeof(DanceFloorDesc));
	int rows;
	int columns;
	fscanf(input, "%d", &rows);
	fscanf(input, "%d", &columns);
	
	desc->rows = rows;
	desc->columns = columns;
	
//	printf("letto righe %d e colonne %d\n", desc->rows, desc->columns);
	
	return desc;
}

StompDescriptor* buildEmptyStomp() {
	StompDescriptor* stomp = malloc(sizeof(StompDescriptor));
	stomp->reached = 3;
	stomp->first = 0;
	stomp->second = 0;
	stomp->third = 0;
	
	return stomp;
}

void reverseStomp(StompDescriptor* stomp) {
	switch(stomp->reached) {
		case 0:
			stomp->first = !stomp->first;
			stomp->second = !stomp->second;
			stomp->third = !stomp->third;
			break;
		case 1:
			stomp->first = !stomp->second;
			stomp->second = !stomp->third;
			stomp->third = 1;
			break;
		case 2:
			stomp->first = !stomp->third;
			stomp->second = 1;
			stomp->third = 1;
			break;
		case 3:
			stomp->first = 1;
			stomp->second = 1;
			stomp->third = 1;
			break;
		default:
			printf("default?!?!?!");
			break;
	}
	stomp->reached = 0;
}

int applyStomp(StompDescriptor* stomp, int currentTile) {
	switch(stomp->reached) {
		case 0:
			if(stomp->first == 1) {
				return !currentTile;
			}
			return currentTile;
			break;
		case 1:
			if(stomp->second == 1) {
				return !currentTile;
			}
			return currentTile;
			break;
		case 2:
			if(stomp->third == 1) {
				return !currentTile;
			}
			return currentTile;
			break;
		case 3:
			return currentTile;
			break;
		default:
			fprintf(stderr, "Il caso default non dovrebbe mai essere eseguito\n");
			break;
	}
	fprintf(stderr, "stomp->reached vale %d e la cosa non dovrebbe accadere.\n", stomp->reached);
	return 0;
}

void incrementReached(StompDescriptor* stomp) {
	if(stomp->reached < 3) {
		stomp->reached += 1;
	}
}

void updateStomp(StompDescriptor* stomp, int currentTile) {
	incrementReached(stomp);
	if(applyStomp(stomp, currentTile) == 1) {
		reverseStomp(stomp);
	}
}

int getLastThreeSum(StompDescriptor* stomp) {
	int tileOne;
	int tileTwo;
	int tileThree;
	
	fscanf(input, "%d", &tileOne);
	fscanf(input, "%d", &tileTwo);
	fscanf(input, "%d", &tileThree);
	
	incrementReached(stomp);
	int tileOneStomped = applyStomp(stomp, tileOne);
	incrementReached(stomp);
	int tileTwoStomped = applyStomp(stomp, tileTwo);
	incrementReached(stomp);
	int tileThreeStomped = applyStomp(stomp, tileThree);
	
	if(tileOneStomped == 0 && tileTwoStomped == 0 && tileThreeStomped == 0) {
		return 0;
	}
	if(tileOneStomped == 1 && tileTwoStomped == 1 && tileThreeStomped == 1) {
		return 0;
	}
	
	return 1;
}

int getUnstompableCurrentRow(int columns) {
	StompDescriptor* stomp = buildEmptyStomp();

	int i=0;
	for(; i<columns-3; i++) {
		int currentTile;
		fscanf(input, "%d", &currentTile);
		//printf("letta tile %d\n", currentTile);
		
		updateStomp(stomp, currentTile);
	}

	return getLastThreeSum(stomp);
}

void writeUnstompable(int unstompable) {
	FILE* output = fopen("output.txt", "w");
	
	fprintf(output, "%d", unstompable);
	
	fclose(output);
}

int main() {
	
	DanceFloorDesc* desc = readDanceFloorDescription();
	
	int unstompable = 0;
	int currRow = 0;
	for(; currRow<desc->rows; currRow++) {
		unstompable += getUnstompableCurrentRow(desc->columns);
	}
	
	writeUnstompable(unstompable);
//	printf("unstompable %d\n", unstompable);
	
	return 1;
}
